include clib.inc

ifdef __ZIP__

include wsub.inc
include dos.inc
include dir.inc
include fblk.inc
include string.inc
include io.inc
include iost.inc
include unzip.inc
include filter.inc
include progress.inc
include malloc.inc
include conio.inc
include syserrls.inc
include doserrls.inc
include errno.inc
include format.inc

	.186

	public	cp_emarchive

DC_MAXOBJ = 5000 ; Max number of files in one subdir (recursive)

PPROC	wzipfindentry, fblk:dword, ziph:word
	push	si
	push	di
	mov	si,ziph
	mov	di,word ptr fblk
	push	word ptr fblk+2
	mov	ax,di
	add	ax,fb_name
	push	ax
	call	strlen
	add	ax,size S_FBLK
	add	di,ax
	push	si
	push	word ptr es:[di+2]
	push	word ptr es:[di]
	push	SEEK_SET
	call	lseek
	push	si
	push	ds
	push	offset zip_local
	push	size S_LZIP
	call	osread
	cmp	ax,size S_LZIP
	jne	wzipfindentry_nul
	cmp	zip_local.lz_pkzip,ZIPHEADERID
	jne	wzipfindentry_nul
	cmp	zip_local.lz_zipid,ZIPLOCALID
	jne	wzipfindentry_nul
	push	si
	mov	ax,zip_local.lz_fnsize
	add	ax,zip_local.lz_extsize
	push	0
	push	ax
	push	SEEK_CUR
	call	lseek
	test	zip_local.lz_flag,8
	jz	wzipfindentry_found
	les	ax,[bp+6]
	mov	ax,es:[di+4]
	mov	zip_local.lz_crc_ax,ax
	mov	ax,es:[di+6]
	mov	zip_local.lz_crc_dx,ax
	mov	ax,es:[di+8]
	mov	zip_local.lz_csize_ax,ax
	mov	ax,es:[di+10]
	mov	zip_local.lz_csize_dx,ax
    wzipfindentry_found:
	mov	ax,1
    wzipfindentry_end:
	or	ax,ax
	pop	di
	pop	si
	ret
    wzipfindentry_nul:
	xor	ax,ax
	jmp	wzipfindentry_end
PEND	wzipfindentry

PPROC	wzipcopyfile, wsub:dword, fblk:dword, out_path:dword
local	fhandle:word
local	fname[WMAXPATH]:byte
	push	si
	push	di
	pushm	fblk
	call	filter_fblk
	or	ax,ax
	jz	wzipcopyfile_end	; 0 == jump
	pushm	wsub
	call	wsopenarch
	mov	si,ax
	inc	ax
	jz	wzipcopyfile_nozip	; -1 == error open
	pushm	fblk
	push	si
	call	wzipfindentry
	jz	wzipcopyfile_nofile	; 0 -> ER_FIND = 11
	mov	ax,word ptr fblk
	add	ax,fb_name
	mov	bx,word ptr fblk+2
	lea	di,fname
	push	bx
	push	ax
	push	ss
	push	di
	push	ss
	push	di
	pushm	out_path
	push	bx
	push	ax
	call	strfcat
	les	bx,fblk
	pushm	es:[bx.fb_size]
	call	progress_set
	jnz	wzipcopyfile_exit	; 66 == ER_USERABORT
	push	ss
	push	di
	call	ogetouth
	cmp	ax,-1
	je	wzipcopyfile_exit	; -1 == error create
	or	ax,ax
	jz	wzipcopyfile_exit	; 0 == jump
	mov	fhandle,ax  		; unzip_handle(AX,DX);
	mov	dx,ax
	les	bx,fblk
	mov	ax,es:[bx]
	mov	zip_attrib,ax
	mov	ax,si
	call	unzip
	push	ax
	push	si
	call	close
	pop	ax
	or	ax,ax
	les	bx,fblk
	jnz	wzipcopyfile_remove
  ifdef __LFN__
	cmp	_ifsmgr,ax
	jne	wzipcopyfile_ifs
  endif
	push	fhandle
	push	es:[bx.fb_date]
	push	es:[bx.fb_time]
	call	setfdate
	push	fhandle
	call	close
  ifdef __LFN__
	jmp	wzipcopyfile_flag
    wzipcopyfile_ifs:
	push	fhandle
	call	close
	push	ss
	push	di
	les	bx,fblk
	push	es:[bx.fb_date]
	push	es:[bx.fb_time]
	call	wsetwrdate
    wzipcopyfile_flag:
  endif
	push	ss
	push	di
	les	bx,fblk
	mov	ax,es:[bx]
	and	ax,_A_FATTRIB
	push	ax
	call	setfattr
	xor	ax,ax
    wzipcopyfile_end:
	pop	di
	pop	si
	ret
    wzipcopyfile_nozip:
	mov	ax,ER_NOZIP
	jmp	wzipcopyfile_end
    wzipcopyfile_nofile:
	push	word ptr fblk+2
	mov	ax,word ptr fblk
	add	ax,fb_name
	push	ax
	mov	dx,offset format_s
	mov	ax,offset CP_ENOENT
	call	@ermsgt
	add	sp,4
	mov	ax,ER_FIND
    wzipcopyfile_exit:
	push	ax
	push	si
	call	close
	pop	ax
	jmp	wzipcopyfile_end
    wzipcopyfile_remove:
	mov	si,fhandle
	push	ss
	push	di
	mov	di,ax
	call	remove
	mov	ax,di
	cmp	ax,ER_USERABORT
	je	wzipcopyfile_exit
	cmp	ax,ER_MEM
	je	wzipcopyfile_ermem
	cmp	ax,ER_DISK
	je	wzipcopyfile_erdisk
	mov	dx,offset CP_DOSER04
	mov	ax,offset cp_emarchive
	jmp	wzipcopyfile_ermsgt
    wzipcopyfile_ermem:
	mov	ax,offset CP_ENOMEM
	jmp	wzipcopyfile_ermsgt
    wzipcopyfile_erdisk:
	mov	dx,offset CP_ENOMEM
	mov	ax,offset CP_DOSER20
    wzipcopyfile_ermsgt:
	call	@ermsgt
	mov	ax,di
	jmp	wzipcopyfile_exit
PEND	wzipcopyfile

PPROC	wzipcopypath, wsub:dword, fblk:dword, out_path:dword
local	SBUF[38]:byte
	push	si
	push	di
	lea	di,[bp-36]
	les	bx,wsub
	xchg	di,bp
	movmmax	[bp.ws_path],es:[bx.ws_path]
	movmmax	[bp.ws_file],es:[bx.ws_file]
	movmmax	[bp.ws_mask],es:[bx.ws_mask]
	mov	si,offset _dsstack
	mov	[si.wp_flag],_W_SORTSIZE
	mov	ax,si
	mov	word ptr [bp.ws_flag],ax
	mov	word ptr [bp.ws_flag+2],ds
	add	ax,wp_arch
	mov	word ptr [bp.ws_arch],ax
	mov	word ptr [bp.ws_arch+2],ds
	mov	[bp.ws_count],0
	mov	[bp.ws_maxfb],DC_MAXOBJ
	xchg	di,bp
	push	ds
	push	ax
	mov	dx,word ptr fblk+2
	mov	ax,word ptr fblk
	add	ax,fb_name
	les	bx,es:[bx.ws_arch]
	cmp	byte ptr es:[bx],0
	je	wzipcopypath_cpy
	push	es
	push	bx
	push	dx
	push	ax
	call	strfcat
	jmp	wzipcopypath_dir
    wzipcopypath_cpy:
	push	dx
	push	ax
	call	strcpy
    wzipcopypath_dir:
	add	si,wp_file
	push	ds
	push	si
	pushm	out_path
	push	word ptr fblk+2
	mov	ax,word ptr fblk
	add	ax,fb_name
	push	ax
	call	strfcat
	push	ds
	push	si
	call	mkdir
	cmp	ax,-1
	je	wzipcopypath_wsub
	push	ds
	push	si
	push	0
	call	setfattr
	or	ax,ax
	jnz	wzipcopypath_wsub
	push	ds
	push	si
	les	bx,fblk
	mov	ax,es:[bx]
	and	ax,_A_FATTRIB
	and	ax,not _A_SUBDIR
	push	ax
	call	setfattr
    wzipcopypath_wsub:
	push	ds
	push	si
	add	si,WMAXPATH
	push	ds
	push	si
	call	strlen
	add	ax,si
	mov	[bp-6],ax
	call	strlen
	sub	si,WMAXPATH
	add	ax,si
	mov	[bp-4],ax
	push	word ptr fblk+2
	mov	ax,word ptr fblk
	add	ax,fb_name
	push	ax
	pushm	out_path
	push	0
	push	0
	call	progress_set
	jnz	wzipcopypath_end
	push	ss
	push	di
	call	wsopen
	or	ax,ax
	jnz	wzipcopypath_read
	dec	ax
	jmp	wzipcopypath_end
    wzipcopypath_read:
	push	ss
	push	di
	call	wzipread
	cmp	ax,1
	ja	wzipcopypath_sort
	push	ss
	push	di
	call	wsclose
	xor	ax,ax
    wzipcopypath_end:
	pop	di
	pop	si
	ret
    wzipcopypath_warning:
	push	ax
	push	ax
	mov	ax,offset cp_warning
	mov	dx,offset cp_emaxfb
	call	@stdmsg
	add	sp,4
	jmp	wzipcopypath_max
    wzipcopypath_sort:
	push	ss
	push	di
	call	wssort
	mov	ax,[di.ws_maxfb]
	cmp	ax,[di.ws_count]
	je	wzipcopypath_warning
    wzipcopypath_max:
	mov	ax,[di.ws_count]
	dec	ax
	mov	[bp-2],ax
	xor	ax,ax
	mov	[bp-38],ax
    wzipcopypath_next:
	cmp	byte ptr [bp-38],0
	jnz	wzipcopypath_close
	mov	ax,[bp-2]
	cmp	ax,1
	jl	wzipcopypath_close
	les	bx,[di.ws_fcb]
	shl	ax,2
	add	bx,ax
	mov	dx,es:[bx+2]
	mov	bx,es:[bx]
	mov	es,dx
	mov	ax,es:[bx]
	and	ax,_A_SUBDIR
	jz	wzipcopypath_file
	push	ss
	push	di
	push	dx
	push	bx
	push	ds
	push	si
	call	wzipcopypath
	mov	[bp-38],ax
	xor	al,al
	mov	bx,[bp-6]
	mov	[bx],al		; *a = 0;
	mov	bx,[bp-4]
	mov	[bx],al		; *p = 0;
	jmp	wzipcopypath_free
    wzipcopypath_close:
	push	ss
	push	di
	call	wsclose
	mov	ax,[bp-38]
	jmp	wzipcopypath_end
    wzipcopypath_file:
	push	dx
	push	bx
	add	bx,fb_name
	push	dx
	push	bx
	push	ds
	push	si
	pushm	es:[bx.fb_size]
	call	progress_set
	mov	[bp-38],ax
	pop	bx
	pop	dx
	jnz	wzipcopypath_close
	push	ss
	push	di
	push	dx
	push	bx
	push	ds
	push	si
	call	wzipcopyfile
	mov	[bp-38],ax
    wzipcopypath_free:
	les	bx,[di.ws_fcb]
	mov	ax,[bp-2]
	shl	ax,2
	add	bx,ax
	xor	ax,ax
	pushm	es:[bx]
	mov     es:[bx],ax
	mov     es:[bx+2],ax
	call	free
	dec	word ptr [bp-2]
	jmp	wzipcopypath_next
PEND	wzipcopypath

PPROC	wzipcopy, wsub:dword, fblk:dword, out_path:dword
	pushm	wsub
	les	bx,fblk
	push	es
	push	bx
	pushm	out_path
	test	byte ptr es:[bx],_A_SUBDIR
	jnz	wzipcopy_sub
	call	wzipcopyfile
    wzipcopy_end:
	ret
    wzipcopy_sub:
	call	wzipcopypath
	jmp	wzipcopy_end
PEND	wzipcopy

_DATA	SEGMENT

cp_emarchive db	'Error in archive',0

_DATA	ENDS

endif

	END
